/**
 * Nicula Iulia Alexandra
 * grupa 334 CB
 * Proiect PM 2017 -- CUBUL
 *------------------------------------------
 * Functii utile pentru initializari si configurarea porturilor
 */

#include "utils.h"

unsigned int selector_nivel[4] = { PD1, PD2, PD3, PD4 };

/* Setare timer pentru a genera intrerupere la fiecare 10ms*/
void init_timer(void) {
    OCR1A = 625;
    
    /* Activare intrerupere de comparare cu OCR1A */
    TIMSK1 = (1 << OCIE1A);
    
    /* Setare prescaler la 256, modul CTC */
    TCCR1B = (4 << CS10) | (1 << WGM12);
}


void initializare(void) {
    /* Configurare pini de pe porturile A si B ca iesiri */
    DDRA = 0xFF;
    DDRB = 0xFF;
    
    /* Configurare iesiri corespunzatoare selectiei nivelurilor, pe port D */
    DDRD |= (1 << PD1) | (1 << PD2) | (1 << PD3) | (1 << PD4);  
    DDRD |= (1 << PD7);
        
    /* Configurare buton PD6 ca intrare si activarea rezistentei de pull-up */
    DDRD &= ~(1 << PD6);
    PORTD |= (1 << PD6);
    PORTD |= (1 << PD7);
    
    init_timer();
}

/* Resetare niveluri */
void resetare_selectie_nivel(void) {
    PORTD &= ~(1 << PD1);
    PORTD &= ~(1 << PD2);
    PORTD &= ~(1 << PD3);
    PORTD &= ~(1 << PD4);
}

void stinge_leduri(void) {
    PORTA = 0x00;
    PORTB = 0x00;
}

void resetare(void) {
    stinge_leduri();
    resetare_selectie_nivel();
}

void select_toate_niv(void) {
    PORTD |= (1 << PD1) | (1 << PD2) | (1 << PD3) | (1 << PD4);
}

void selecteaza_nivel(int i) {
    PORTD |= (1 << selector_nivel[i]);
}

void stinge_nivel(int i) {
    PORTD &= ~(1 << selector_nivel[i]);
}



